local self = ...

print("[" ..self._type.. "] type loaded")

function self.create(element)
	element.memhiOriginal = element.memhi
	element.memhi = {}
	local mt = {
		__index = function(t,k)
			print("[" ..element.memhiOriginal._type.. " " ..tostring(element.memhiOriginal._id).. "] access: " ..tostring(k))
			return element.memhiOriginal[k]
		end,
		__newindex = function(t,k,v)
			print("[" ..element.memhiOriginal._type.. " " ..tostring(element.memhiOriginal._id).. "] set: " ..tostring(k).. " = " ..tostring(v))
			element.memhiOriginal[k] = v
		end
	}
	setmetatable(element.memhi,mt)
	print("[" ..element.memhi._type.. " " ..tostring(element.memhi._id).. "] element created")
end

function self.destroy(element)
	print("[" ..element.memhi._type.. " " ..tostring(element.memhi._id).. "] element destroyed")
end

function self.unload()
	print("[" ..self._type.. "] type unloaded")
end